package de.intevation.flys.client.client.ui;

import com.smartgwt.client.widgets.form.fields.FormItem;
import com.smartgwt.client.widgets.form.fields.IntegerItem;
import com.smartgwt.client.widgets.form.validator.IntegerRangeValidator;
import com.smartgwt.client.widgets.form.validator.Validator;

import de.intevation.flys.client.shared.model.DataList;


public class IntegerRangePanel extends RangePanel {

    protected Integer maxLower;
    protected Integer maxUpper;


    @Override
    protected FormItem newFormItem(String name) {
        IntegerItem item = new IntegerItem(name, "");
        item.setShowTitle(false);

        return item;
    }


    @Override
    protected Validator[] createLowerValidators(DataList dataList) {
        Validator validator = newRangeValidator();

        if (validator != null) {
            return new Validator[] { validator };
        }

        return null;
    }


    @Override
    protected Validator[] createUpperValidators(DataList dataList) {
        Validator validator = newRangeValidator();

        if (validator != null) {
            return new Validator[] { validator };
        }

        return null;
    }


    protected Validator newRangeValidator() {
        Integer maxLower = getMaxLower();
        Integer maxUpper = getMaxUpper();

        if (maxLower != null && maxUpper != null) {
            IntegerRangeValidator validator = new IntegerRangeValidator();
            validator.setMax(maxUpper);
            validator.setMin(maxLower);

            return validator;
        }

        return null;
    }


    public Integer getMaxLower() {
        return maxLower;
    }


    public void setMaxLower(Integer maxLower) {
        this.maxLower = maxLower;
    }


    public Integer getMaxUpper() {
        return maxUpper;
    }


    public void setMaxUpper(Integer maxUpper) {
        this.maxUpper = maxUpper;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
